#include <iostream>
#include <string>
#include <stdlib.h>
#include <zmq.hpp>

using namespace std;


int main(int argc,char *argv[])
{
	if (argc != 2)
	{
		cerr << "Usage: sub <endpoint>" << endl;
		exit(-1);
	}

	int ret = 0;
	string filter("tango://kidiboo.esrf.fr:10000/dserver/devtest/api.change");
	string endpoint(argv[1]);

	try
	{
		zmq::context_t ctx(1);

		zmq::socket_t subscriber(ctx, ZMQ_SUB);

		subscriber.setsockopt(ZMQ_SUBSCRIBE,filter.c_str(),filter.size());
		subscriber.connect(endpoint.c_str());

		cout << "Subscriber connected" << endl;

		int ctr = 0;
		while (1)
		{
			zmq::message_t received1,received2,received3,received4;

			subscriber.recv(&received1);
			subscriber.recv(&received2);
			subscriber.recv(&received3);
			subscriber.recv(&received4);

			int *receiv_ctr = (int *)received2.data();
			cout << "Received message number " << *receiv_ctr << endl;
			ctr++;
		}
	}
	catch (zmq::error_t &e)
	{
		cerr << "A zmq exception" << endl;
		cerr << "Error code = " << e.num() << endl;
		cerr << "Error message = " << e.what() << endl;

		ret = -1;
	}
	catch (...)
	{
		cerr << "Gasp an unknown exception" << endl;
		ret = -1;
	}

	cout << "Exiting" << endl;
	return ret;
}

